# ------------------------------------------------------------
# A wish init script to make it possible for
# Tcl/Tk and erlang to communicate.
# Written by Ola Samuelsson in August 1995
#  Ericsson Software Technology AB / Erlang Systems
# ------------------------------------------------------------

# Protocol:
# \1 =   it's an event
# \2 =   it's a reply for a call
# \3 =   it's a error reply for call
# \4 =   it's an error
# \5 =   stopbyte (end of message)

global command
set command ""

proc dbg {str} {
   .console.e insert 0.0 "$str\n"
   update idletasks
}

proc erlsend {w1 {w2 ""} {w3 ""} {w4 ""} {w5 ""} {w6 ""} {w7 ""} {w8 ""}} {
    global sock
	set msg [concat $w1 $w2 $w3 $w4 $w5 $w6 $w7 $w8]
	puts -nonewline $sock "\1$msg\5"
	flush $sock
}

proc erlcall {w} {
    global sock
    set errcode [catch $w result]
    if {$errcode == 0} {
	puts -nonewline $sock "\2$result\5"
	flush $sock
    } else {
	puts -nonewline $sock "\3$result\5"
	flush $sock
    }
}

proc erlexec {w} {
    set errcode [catch $w result]
    if {$errcode != 0} {
	erlerror $result
    }
}

proc erlerror {w} {
    global sock
    puts -nonewline $sock "\4$w\5"
    flush $sock
}

proc get_sock {} {
  global sock
  dbg "getting sock"
  do_read
  dbg "got sock"
}

proc timer_sock {} {
  dbg "\ntimer sock"
  do_read
}

proc make_dbg_console {} {
    toplevel .console
    button .console.fb -text "get sock" -command get_sock
    text .console.e
    pack .console.e 
    pack .console.fb
    dbg "tcl socket port is:$portno"
    update idletasks
}

set portno $argv
# make_dbg_console
wm withdraw .

global sock
set sock [socket 127.0.0.1 $portno]
fconfigure $sock -blocking false -translation auto -buffering none

fileevent $sock readable do_read

proc do_read {} {
    global sock command
    set errcode [catch {gets $sock} line]
    if {$errcode != 0} {
	exit
    }
    set a [eof $sock]
    if [eof $sock] { exit }
    append command "$line\n"
    if [info complete "${command}\n"] {
	catch {eval $command} msg
	set command ""
    }
}

